<?php

namespace TVn7\Migrations;

use Doctrine\DBAL\Migrations\AbstractMigration;
use Doctrine\DBAL\Schema\Schema;
use Symfony\Component\DependencyInjection\ContainerAwareInterface;
use Symfony\Component\DependencyInjection\ContainerAwareTrait;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20171021202543 extends AbstractMigration implements ContainerAwareInterface
{

    use ContainerAwareTrait;

    /**
     * @param Schema $schema
     */
    public function up(Schema $schema)
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'mysql', 'Migration can only be executed safely on \'mysql\'.');
    }

    public function postUp(Schema $schema)
    {
        $em = $this->container->get('doctrine')->getManager();

        $postesRepo = $em->getRepository('TVn7UserBundle:Poste');
        $this->write("Update Postes");

        $posteRoleMapping = [
            "respo-informatique" => "ROLE_SFTP"
            ];
        foreach ($posteRoleMapping as $posteCanonicalName => $role) {
            $poste = $postesRepo->findBy(["name_canonical" => $posteCanonicalName]);
            if (count($poste) == 1) {
                $poste = $poste[0];
                $this->write(" Add '" . $role . "' to '" . $poste->getName() . "'");
                $poste->addRole($role);
                $membres = $poste->getMembres()->filter(function($m) {
                    return in_array($m->getAnnee(), [2017, 2018, 2019]);
                });
                foreach ($membres as $membre) {
                    $this->write("  Add '" . $role . "' to '" . $membre . "' (" . $membre->getUsername() . ")");
                    $membre->addRole($role);
                }
            }
        }
        $userRepo = $em->getRepository('TVn7UserBundle:Membre');
        $membres = $userRepo->findAll();

        foreach($membres as $membre) {
            if($membre->hasRole("ROLE_ADMIN_TOOLS") && !$membre->hasRole("ROLE_SFTP")) {
                $membre->removeRole("ROLE_ADMIN_TOOLS");
                $membre->addRole("ROLE_SFTP");
                $this->write("  Change 'ROLE_ADMIN_TOOLS' to 'ROLE_SFTP' for user '" . $membre . "' (" . $membre->getUsername() . ")");
            }
        }
        
        $em->flush();

    }

    /**
     * @param Schema $schema
     */
    public function down(Schema $schema)
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->abortIf($this->connection->getDatabasePlatform()->getName() !== 'mysql', 'Migration can only be executed safely on \'mysql\'.');

    }
}
